/*

Line by the [equalization-line algorithm]

Anton (Liloi) Moskalenko
e-mail: liloi@mail.ru
web: http://liloisproj.narod.ru/

B0: 21.09.06 1
E0: 21.09.06 1

*/

#ifndef ST_LINE
#define ST_LINE

#include <math.h>

///////////////////////////////////////////////////////////////

void st_line(float, float, float, float);

///////////////////////////////////////////////////////////////

void put_to(int __x, int __y)
{
// Place here code for put pixel at coordinates __x, __y
}

///////////////////////////////////////////////////////////////

void st_line(float __ax, float __ay, float __bx, float __by)
{

        int y = 0;

        float iax=__ax,iay=__ay,ibx=__bx,iby=__by;
        
        if(abs(iax-ibx)>=abs(iay-iby))
        {
                if(__ax>__bx) {iax=__bx; ibx=__ax; iay=__by; iby=__ay;}

                for(int i=iax;i<=ibx;i++)
                {
                        y = (((i-iax)*(iby-iay))/(ibx-iax))+iay;
                        put_to(i,y);
                }
        }else
        {
                if(__ay>__by) {iax=__bx; ibx=__ax; iay=__by; iby=__ay;}

                for(int i=iay;i<=iby;i++)
                {
                        y = (((i-iay)*(ibx-iax))/(iby-iay))+iax;
                        put_to(y,i);
                }
        }

}

///////////////////////////////////////////////////////////////

#endif

//

